<!DOCTYPE html>
<html>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1">

<!-- font -->
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

<!-- Bootstrap -->
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

<body onload="onPageLoading()">

  <!-- Menu -->
  <div class="container-fluid bg-light">
    <div class="row">
      <div class="col-sm-12">
        <nav class="navbar fixed-top navbar-expand-sm navbar-light bg-light">
          <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav"
            aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarNav">
            <ul class="navbar-nav nav-fill w-100">
              <li class="nav-item active">
                <a class="nav-link" href="#">Home</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" href="#plans">Plans</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" href="#about">About</a>
              </li>
              <li class="nav-item">
                <button class="btn" id="nav-order-detail">Order Detail</button>
              </li>
            </ul>
          </div>
        </nav>
      </div>
    </div>
  </div>

  <!-- Content -->
  <div class="container" style="padding: 120px 0 50px 0;">
    <div class="row">
      <div class="col-sm-12">
        <div class="row">
          <!-- Title row home -->
          <div class="col-sm-12">
            <h1><b>Pizza 365</b></h1>
            <h1><i><b>Truly italian !</b></i></h1>
          </div>

          <!-- Slide row home -->
          <div class="col-sm-12">
            <div id="carouselExampleIndicators" class="carousel slide" data-ride="carousel">
              <ol class="carousel-indicators">
                <li data-target="#carouselExampleIndicators" data-slide-to="0" class="active"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="1"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="2"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="3"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="4"></li>
              </ol>
              <div class="carousel-inner">
                <div class="carousel-item active">
                  <img class="d-block w-100" src="images/mon_y_1.jpg" alt="First slide">
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/mon_y_2.jpg" alt="Second slide">
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/mon_y_3.jpg" alt="Third slide">
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/mon_y_4.jpg" alt="Fourth slide">
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/mon_y_5.jpg" alt="Fifth slide">
                </div>
              </div>
              <a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
                <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                <span class="sr-only">Previous</span>
              </a>
              <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
                <span class="carousel-control-next-icon" aria-hidden="true"></span>
                <span class="sr-only">Next</span>
              </a>
            </div>
          </div>

          <!-- Title what we offer -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom text-warning">Tại sao lại Pizza 365:</b></h2>
          </div>

          <!-- Content what we offer -->
          <div class="col-sm-12">
            <div class="row">
              <div class="col-sm-3 p-4 border" style="background-color:#fce7ca">
                <h3 class="p-2">Hương vị<br>độc đáo</h3>
                <p class="p-2">Công thức làm bánh từ các thợ làm bánh pizza hàng đầu</p>
              </div>
              <div class="col-sm-3 p-4 border" style="background-color:#ffdfb3">
                <h3 class="p-2">Đa dạng<br>thực đơn</h3>
                <p class="p-2">Có nhiều loại và kích cỡ khác nhau để lựa chọn</p>
              </div>
              <div class="col-sm-3 p-4 border" style="background-color:#fcd092">
                <h3 class="p-2">Mức giá rất<br>hấp dẫn</h3>
                <p class="p-2">Giá cả cạnh tranh so với mặt bằng thị trường</p>
              </div>
              <div class="col-sm-3 p-4 border" style="background-color:#fcc26f">
                <h3 class="p-2">Chương trình<br>khuyến mại</h3>
                <p class="p-2">Chính sách giảm giá cho khánh hàng có voucher</p>
              </div>
            </div>
          </div>
        </div>

        <div id="plans" class="row">
          <!-- Title what we offer -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-1 border-bottom">Menu Combo Pizza 365</b></h2>
            <p><span class="p-2">Hãy chọn cỡ pizza phù hợp với bạn!</span></p>
          </div>
          <!-- Content what we offer -->
          <div class="col-sm-12">
            <div class="row">
              <div class="col-sm-4">
                <div class="card">
                  <div class="card-header bg-dark text-white text-center">
                    <h3>S (small)</h3>
                  </div>
                  <div class="card-body text-center">
                    <ul class="list-group list-group-flush">
                      <li class="list-group-item">Đường kính: <b>20 cm</b></li>
                      <li class="list-group-item">Sườn nướng: <b>2</b></li>
                      <li class="list-group-item">Salad: <b>200 g</b></li>
                      <li class="list-group-item">Nước ngọt: <b>2</b></li>
                      <li class="list-group-item">
                        <h1><b>150.000</b></h1> VND
                      </li>
                    </ul>
                  </div>
                  <div class="card-footer text-center">
                    <button class="btn btn-success" id="btn-size-S" onclick="onBtnSelectSizeClick('Size S')">Chọn</button>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card">
                  <div class="card-header bg-secondary text-white text-center">
                    <h3>M (medium)</h3>
                  </div>
                  <div class="card-body text-center">
                    <ul class="list-group list-group-flush">
                      <li class="list-group-item">Đường kính: <b>25 cm</b></li>
                      <li class="list-group-item">Sườn nướng: <b>4</b></li>
                      <li class="list-group-item">Salad: <b>300 g</b></li>
                      <li class="list-group-item">Nước ngọt: <b>3</b></li>
                      <li class="list-group-item">
                        <h1><b>200.000</b></h1> VND
                      </li>
                    </ul>
                  </div>
                  <div class="card-footer text-center">
                    <button class="btn btn-success" id="btn-size-M" onclick="onBtnSelectSizeClick('Size M')">Chọn</button>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card">
                  <div class="card-header bg-dark text-white text-center">
                    <h3>L (large)</h3>
                  </div>
                  <div class="card-body text-center">
                    <ul class="list-group list-group-flush">
                      <li class="list-group-item">Đường kính: <b>30 cm</b></li>
                      <li class="list-group-item">Sườn nướng: <b>8</b></li>
                      <li class="list-group-item">Salad: <b>500 g</b></li>
                      <li class="list-group-item">Nước ngọt: <b>4</b></li>
                      <li class="list-group-item">
                        <h1><b>250.000</b></h1> VND
                      </li>
                    </ul>
                  </div>
                  <div class="card-footer text-center">
                    <button class="btn btn-success" id="btn-size-L" onclick="onBtnSelectSizeClick('Size L')">Chọn</button>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>

        <div id="about" class="row">
          <!-- Title Who We Are -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom">Chọn loại Pizza</b></h2>
          </div>

          <!-- Content Who We Are -->
          <div class="col-sm-12">
            <div class="row">
              <div class="col-sm-4">
                <div class="card w-100" style="width: 18rem;">
                  <img src="images/pizza_type_1.jpg" class="card-img-top">
                  <div class="card-body">
                    <h3>Hawaii</h3>
                    <p></p>
                    <p>Pizza Hawaii</p>
                    <p><button class="btn btn-info w-100" id="btn-type-hawaii" onclick="onBtnSelectTypeClick('hawaii')">Chọn</button></p>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card w-100" style="width: 18rem;">
                  <img src="images/pizza_type_2.jpg" class="card-img-top">
                  <div class="card-body">
                    <h3>Hải sản</h3>
                    <p></p>
                    <p>Pizza hải sản</p>
                    <p><button class="btn btn-info w-100" id="btn-type-seafood" onclick="onBtnSelectTypeClick('seafood')">Chọn</button></p>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card w-100" style="width: 18rem;">
                  <img src="images/pizza_type_3.jpg" class="card-img-top">
                  <div class="card-body">
                    <h3>Thịt hun khói</h3>
                    <p></p>
                    <p>Pizza thịt hun khói</p>
                    <p><button class="btn btn-info w-100" id="btn-type-bacon" onclick="onBtnSelectTypeClick('bacon')">Chọn</button></p>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom">Chọn đồ uống</b></h2>
          </div>
          <div class="col-sm-12">
            <div class="form-group">
              <label>Hãy chọn đồ uống bạn yêu thích</label>
              <select id="select-drink" class="form-control">
                <option value="">Chọn đồ uống</option>
              </select>
            </div>
          </div>
        </div>

        <div id="contact" class="row">
          <!-- Title Contact Us -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom">Contact Us</b></h2>
          </div>

          <!-- Content Contact Us -->
          <div class="col-sm-12">
            <div class="row">
              <div class="col-sm-12">
                <div class="form-group">
                  <label for="fullname">Họ và tên</label>
                  <input type="text" class="form-control" id="inp-fullname" placeholder="Họ và tên">
                </div>
                <div class="form-group">
                  <label for="email">Email</label>
                  <input type="text" class="form-control" id="inp-email" placeholder="Email">
                </div>
                <div class="form-group">
                  <label for="dien-thoai">Điện thoại</label>
                  <input type="text" class="form-control" id="inp-dien-thoai" placeholder="Điện thoại">
                </div>
                <div class="form-group">
                  <label for="dia-chi">Địa chỉ</label>
                  <input type="text" class="form-control" id="inp-dia-chi" placeholder="Địa chỉ">
                </div>
                <div class="form-group">
                  <label for="message">Lời nhắn</label>
                  <input type="text" class="form-control" id="inp-message" placeholder="Lời nhắn">
                </div>
                <div class="form-group">
                  <label for="voucherID">Mã giảm giá (voucher ID)</label>
                  <input type="text" class="form-control" id="inp-voucherID" placeholder="Mã giảm giá">
                </div>
                <button type="button" class="btn btn-dark w-100" onclick="onBtnCheckOrderClick()">Kiểm tra đơn</button>
              </div>
            </div>
          </div>
          <div id="div-container-order" class="container bg-info mt-4 p-2 jumbotron" style="display: none;">
            <div id="div-order-infor" class="text-white p-3">...</div>
            <div class="p-2">
              <button type="button" id="btn-send-order" class="btn btn-warning w-100" onclick="onBtnSendOrderClick(this)">Gửi đơn</button>
            </div>
          </div>
          <div id="div-display-orderId" class="container bg-warning mt-4 p-2 jumbotron" style="display: none">
            <p>Cảm ơn bạn đã đặt hàng tại Pizza 365. Mã đơn hàng của bạn là:</p>
            <div class="form-group">
              <label>Mã đơn hàng</label>
              <input type="text" id="input-orderId" class="form-control" disabled>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Footer -->
  <div class="container-fluid bg-light p-5">
    <div class="row text-center">
      <div class="col-sm-12">
        <h4 class="m-2">Footer</h4>
        <a href="#" class="btn btn-dark m-3"><i class="fa fa-arrow-up"></i>To the top</a>
        <div class="m-2">
          <i class="fa fa-facebook-official w3-hover-opacity"></i>
          <i class="fa fa-instagram w3-hover-opacity"></i>
          <i class="fa fa-snapchat w3-hover-opacity"></i>
          <i class="fa fa-pinterest-p w3-hover-opacity"></i>
          <i class="fa fa-twitter w3-hover-opacity"></i>
          <i class="fa fa-linkedin w3-hover-opacity"></i>
        </div>
      </div>
    </div>
  </div>
</body>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201;
  // bạn có thê dùng để lưu trữ combo được chọn, mỗi khi khách chọn bạn lại đổi giá trị properties của nó
    var gSelectedMenuStructure = {
      menuName: "",    // S, M, L
      duongKinhCM: 0,
      suonNuong: 0,
      saladGr: 0,
      drink: 0,
      priceVND: 0
    }
  // bạn có thể dùng để lưu loại pizza đươc chọn, mỗi khi khách chọn, bạn lại đổi giá trị cho nó
    var gSelectedPizzaType = ""

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() { // hàm xử lý sự kiện load trang
    console.log("Chạy hàm xử lý khi load trang");
    loadDataToSelectDrink()
  }
  function onBtnSelectSizeClick(paramSize) { // hàm chạy khi ấn nút chọn combo size
    if(paramSize == "Size S") {
      var vSelectedMenuStructure = getSize("Size S", 20, 2, 200, 2, 150000);
    }
    else if(paramSize == "Size M") {
      var vSelectedMenuStructure = getSize("Size M", 25, 4, 300, 3, 200000);
    }
    else if(paramSize == "Size L") {
      var vSelectedMenuStructure = getSize("Size L", 30, 8, 500, 4, 250000);
    }
    vSelectedMenuStructure.displayInConsoleLog();
    changeSizeButtonColor(paramSize);
    gSelectedMenuStructure = vSelectedMenuStructure; 
  }
  function onBtnSelectTypeClick(paramType) { // hàm chạy khi ấn nút chọn loại pizza
    gSelectedPizzaType = paramType;
    console.log("%cĐã chọn loại pizza: " + paramType, "color:blue");
    changeTypeButtonColor(paramType);
  }
  function onBtnCheckOrderClick() { // hàm chạy khi ấn nút kiểm tra đơn
    var vUserObj = { // khai báo biến cục bộ là đối tượng khách hàng 
      menuDuocChon: "",
      loaiPizza: "",
      loaiNuocUong: "",
      hoVaTen: "",
      email: "",
      dienThoai: "",
      diaChi: "",
      loiNhan: "",
      voucherID: "",
      phaiThanhToanVND: function () {}
    };
    //bước 1: thu thập thông tin khách hàng
    getUserInput(vUserObj);
    console.log("%cGhi tạm thông tin khách hàng ra console", "color:blue");
    console.log(vUserObj);
    //bước 2: kiểm tra thông tin khách hàng
    var vCheckUserInputResult = validateUserInput(vUserObj);
    //bước 3: hiển thị thông tin nếu hợp lệ
    if (vCheckUserInputResult == true) {
      console.log("%cThông tin hợp lệ!", "color:blue")
      displayUserOrder(vUserObj);
    }
  }
  function onBtnSendOrderClick(paramButton) { //hàm chạy khi ấn nút gửi order
    //B1: tạo đối tượng chứa thông tin order cần tạo
    var vOrderObjRequest = {
      kichCo: paramButton.getAttribute("data-kich-co"),
      duongKinh: paramButton.getAttribute("data-duong-kinh"),
      suon: paramButton.getAttribute("data-suon"),
      salad: paramButton.getAttribute("data-salad"),
      loaiPizza: paramButton.getAttribute("data-loai-pizza"),
      idVourcher: paramButton.getAttribute("data-voucher-id"),
      idLoaiNuocUong: paramButton.getAttribute("data-ma-nuoc-uong"),
      soLuongNuoc: paramButton.getAttribute("data-so-luong-nuoc"),
      hoTen: paramButton.getAttribute("data-ho-ten"),
      thanhTien: paramButton.getAttribute("data-thanh-tien"),
      email: paramButton.getAttribute("data-email"),
      soDienThoai: paramButton.getAttribute("data-so-dien-thoai"),
      diaChi: paramButton.getAttribute("data-dia-chi"),
      loiNhan: paramButton.getAttribute("data-loi-nhan")
    };
    console.log("%cGhi tạm thông tin order cần tạo ra console", "color:orange");
    console.log(vOrderObjRequest);
    //B2: kiểm tra thông tin
    //B3: tạo request
    var vXmlHttp = new XMLHttpRequest();
    callApiCreateOrder(vXmlHttp, vOrderObjRequest); //mở và gửi request tạo order
    //B4: xử lý response
    vXmlHttp.onreadystatechange = function () {
      if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS) {
        handleCreateOrderResponse(this) // xử lý response của request tạo order
      }
    }
  }
  function onNavOrderDetailClick(paramNav) {
    var vId = paramNav.getAttribute("data-id");
    var vOrderId = paramNav.getAttribute("data-order-id");
    var vUrlToGo = "viewOrder.html" + "?id=" + vId
                                    + "&orderId=" + vOrderId
    window.location.href = vUrlToGo                                
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function getSize(paramSize, paramDuongKinhCM, paramSuonNuong, paramSaladGr, paramDrink, paramPriceVND) {
    var vSelectedMenuStructure = {  //Đối tượng: cỡ pizza được chọn
      menuName: paramSize,   //size = S/M/L
      duongKinhCM: paramDuongKinhCM,
      suonNuong: paramSuonNuong,
      saladGr: paramSaladGr,
      drink: paramDrink,
      priceVND: paramPriceVND,
      displayInConsoleLog() {
        console.log("%cPIZZA SIZE SELECTED - cỡ pizza được chọn.....", "color:blue");
        console.log(this.menuName + "; Đường kính: " + this.duongKinhCM + " cm"
                  + "; Sườn nướng: " + this.suonNuong + "; Salad: " + this.saladGr + " gram"
                  + "; Nước ngọt: " + this.drink + "; Giá tiền: " + this.priceVND + " VND");
      }
    }
    return vSelectedMenuStructure;  //trả lại đối tượng, có đủ dữ liệu (attribute) và các methods (phương thức)
  }
  function changeSizeButtonColor(paramSize) { // hàm đổi màu nút chọn combo size
    var vBtnSizeS = document.getElementById("btn-size-S");  
    var vBtnSizeM = document.getElementById("btn-size-M"); 
    var vBtnSizeL = document.getElementById("btn-size-L");
    
    if (paramSize === "Size S") {
      vBtnSizeS.className = "btn btn-warning";
      vBtnSizeM.className = "btn btn-success";
      vBtnSizeL.className = "btn btn-success";
    }
    else if (paramSize === "Size M") { 
      vBtnSizeS.className = "btn btn-success";
      vBtnSizeM.className = "btn btn-warning";
      vBtnSizeL.className = "btn btn-success";
    } 
    else if (paramSize === "Size L") { 
      vBtnSizeS.className = "btn btn-success";
      vBtnSizeM.className = "btn btn-success";
      vBtnSizeL.className = "btn btn-warning";
    }
  }
  function changeTypeButtonColor(paramType) { // hàm đổi màu nút chọn loại pizza
    var vBtnTypeHawaii = document.getElementById("btn-type-hawaii");  
    var vBtnTypeSeafood = document.getElementById("btn-type-seafood"); 
    var vBtnTypeBacon = document.getElementById("btn-type-bacon");
    
    if (paramType === "hawaii") {
      vBtnTypeHawaii.className = "btn btn-warning w-100";
      vBtnTypeSeafood.className = "btn btn-info w-100";
      vBtnTypeBacon.className = "btn btn-info w-100";
    }
    else if (paramType === "seafood") { 
      vBtnTypeHawaii.className = "btn btn-info w-100";
      vBtnTypeSeafood.className = "btn btn-warning w-100";
      vBtnTypeBacon.className = "btn btn-info w-100";
    } 
    else if (paramType === "bacon") { 
      vBtnTypeHawaii.className = "btn btn-info w-100";
      vBtnTypeSeafood.className = "btn btn-info w-100";
      vBtnTypeBacon.className = "btn btn-warning w-100";
    }
  }
  function loadDataToSelectDrink() { // hàm đổ dữ liệu vào select drink
    console.log("Chạy hàm đổ dữ liệu vào select drink");
    // bước 3: tạo request lấy dữ liệu drinks
    var Xhttp = new XMLHttpRequest();
    callApiGetDrinkData(Xhttp);
    Xhttp.onreadystatechange = function () {
      if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
        // bước 4: đổ dữ liệu vào select drink
        handleLoadDataToSelectDrink(Xhttp)
      }
    };
  }
  function callApiGetDrinkData(paramRequest) { // hàm mở và gửi request đến server
    paramRequest.open("GET", "http://42.115.221.44:8080/devcamp-pizza365/drinks", true);
    paramRequest.send();
  }
  function handleLoadDataToSelectDrink(paramRequest) { // hàm xử lý response
    console.log(paramRequest.responseText);
    var vDrinkList = JSON.parse(paramRequest.responseText);
    var vSelectDrink = document.getElementById("select-drink");
    for (var bI = 0; bI < vDrinkList.length; bI ++) {
      var bDrinkOption = document.createElement("option");
      bDrinkOption.value = vDrinkList[bI].maNuocUong;
      bDrinkOption.text = vDrinkList[bI].tenNuocUong;
      vSelectDrink.appendChild(bDrinkOption)
    }
  }
  function getUserInput(paramUserObj) { // hàm lấy thông tin khách hàng
    var vSelectDrink = document.getElementById("select-drink");
    var vInputFullname = document.getElementById("inp-fullname");
    var vInputEmail = document.getElementById("inp-email");
    var vInputDienThoai = document.getElementById("inp-dien-thoai");
    var vInputDiaChi = document.getElementById("inp-dia-chi");
    var vInputMessage = document.getElementById("inp-message");
    var vInputVoucherID = document.getElementById("inp-voucherID");

    paramUserObj.menuDuocChon = gSelectedMenuStructure;
    paramUserObj.loaiPizza = gSelectedPizzaType;
    paramUserObj.loaiNuocUong = vSelectDrink.value;
    paramUserObj.hoVaTen = vInputFullname.value.trim();
    paramUserObj.email = vInputEmail.value.trim();
    paramUserObj.dienThoai = vInputDienThoai.value.trim();
    paramUserObj.diaChi = vInputDiaChi.value.trim();
    paramUserObj.loiNhan = vInputMessage.value.trim();
    paramUserObj.voucherID = vInputVoucherID.value.trim();
  }
  function validateUserInput(paramUserObj) { // hàm kiểm tra thông tin khách hàng
    var vCheckResult = false;
    if (paramUserObj.menuDuocChon.menuName == "") {
      console.log("%cChưa chọn cỡ pizza", "color:red");
      alert("Chưa chọn cỡ pizza");
    }
    else if (paramUserObj.loaiPizza == "") {
      console.log("%cChưa chọn loại pizza", "color:red");
      alert("Chưa chọn loại pizza");
    }
    else if (paramUserObj.loaiNuocUong == "") {
      console.log("%cChưa chọn loại nước uống", "color:red");
      alert("Chưa chọn loại nước uống");
    }
    else if (paramUserObj.hoVaTen == "") {
      console.log("%cChưa nhập họ và tên", "color:red");
      alert("Chưa nhập họ và tên");
    }
    else if (validateEmail(paramUserObj.email) == true) {
      if (validatePhoneNumber(paramUserObj.dienThoai) == true) {
        if (paramUserObj.diaChi == "") {
          console.log("%cChưa nhập địa chỉ", "color:red");
          alert("Chưa nhập địa chỉ");
        }
        else {
          vCheckResult = true
        }
      }
    }
    return vCheckResult
  }
  function validateEmail(paramEmail) { // hàm kiểm tra email
    var vCheckResult = false;
    if (paramEmail == "") {
      console.log("%cChưa nhập email", "color:red");
      alert("Chưa nhập email");
    }
    else if (!paramEmail.includes("@")) {
      console.log("%cEmail phải chứa ký tự @", "color:red");
      alert("Email phải chứa ký tự @");
    }
    else if (paramEmail.startsWith("@") || paramEmail.endsWith("@")) {
      console.log("%cEmail phải có ký tự trước và sau @", "color:red");
      alert("Email phải có ký tự trước và sau @");
    }
    else {
      vCheckResult = true
    }
    return vCheckResult
  }
  function validatePhoneNumber(paramPhoneNumber) { // hàm kiểm tra số điện thoại
    var vCheckResult = false;
    if (paramPhoneNumber == "") {
      console.log("%cChưa nhập số điện thoại", "color:red");
      alert("Chưa nhập số điện thoại");
    }
    else if (isNaN(paramPhoneNumber)) {    
      console.log("%cSố điện thoại phải là dãy số nguyên dương", "color:red");
      alert("Số điện thoại phải là dãy số nguyên dương");
    }
    else {
      var vChuyenSo = Number(paramPhoneNumber);
      if (!Number.isInteger(vChuyenSo) || vChuyenSo <= 0) { 
        console.log("%cSố điện thoại phải là dãy số nguyên dương", "color:red");
        alert("Số điện thoại phải là dãy số nguyên dương");
      }     
      else {
        vCheckResult = true
      }
    }
    return vCheckResult
  }
  function displayUserOrder(paramUserObj) { // hàm hiển thị thông tin người dùng
    var vDiscount = getDiscount(paramUserObj.voucherID); //tìm phần trăn giảm theo voucher ID;  
    paramUserObj.phaiThanhToanVND = function () {
      return (this.menuDuocChon.priceVND * (1 - vDiscount / 100)) //tính số tiền phải thanh toán sau giảm giá
    };
    var vSelectDrink = document.getElementById("select-drink");
    document.getElementById("div-container-order").style.display = "block"; // hiện order ra
    document.getElementById("div-order-infor").innerHTML = "Họ và tên: " + paramUserObj.hoVaTen
      + "<br>Email: " + paramUserObj.email
      + "<br>Số điện thoại: " + paramUserObj.dienThoai
      + "<br>Địa chỉ: " + paramUserObj.diaChi
      + "<br>Lời nhắn: " + paramUserObj.loiNhan
      + "<br>......................................................................... "
      + "<br>Kích cỡ: " + paramUserObj.menuDuocChon.menuName
      + "<br>Đường kính: " + paramUserObj.menuDuocChon.duongKinhCM + " cm"
      + "<br>Sườn nướng: " + paramUserObj.menuDuocChon.suonNuong
      + "<br>Salad: " + paramUserObj.menuDuocChon.saladGr + " gram"
      + "<br>Nước ngọt: " + paramUserObj.menuDuocChon.drink
      + "<br>......................................................................... "
      + "<br>Loại pizza: " + paramUserObj.loaiPizza
      + "<br>Loại nước uống: " + vSelectDrink[vSelectDrink.selectedIndex].text
      + "<br>Mã giảm giá (voucher): " + paramUserObj.voucherID
      + "<br>Giá: " + paramUserObj.menuDuocChon.priceVND + " VND"
      + "<br>Discount: " + vDiscount + " %"
      + "<br>Phải thanh toán: " + paramUserObj.phaiThanhToanVND() + " VND";
    loadUserOrderToSendOrderButton(paramUserObj); //đổ thông tin order vào nút gửi order
  }
  function getDiscount(paramVoucherID) { // hàm lấy phần trăm giảm giá
    var vDiscount = 0;
    if (paramVoucherID == "") {
      console.log("Không nhập voucher ID");
    }
    else { // nếu mã giảm giấ đã nhập, tạo xmlHttp  request và gửi về server
      const vBASE_URL = "http://42.115.221.44:8080/devcamp-voucher-api/voucher_detail";
      var vXmlHttp = new XMLHttpRequest();
      vXmlHttp.open("GET", vBASE_URL + "/" + paramVoucherID, false);
      vXmlHttp.send(null);
      if (vXmlHttp.status == gREQUEST_STATUS_OK) { // restFullAPI successful
        console.log("Tìm thấy mã voucher. Response text là:");
        console.log(vXmlHttp.responseText);
        var vVoucherObj = JSON.parse(vXmlHttp.responseText); //chuyển responseText thành object
        console.log("Phần trăm giảm giá là: " + vVoucherObj.phanTramGiamGia);
        vDiscount = vVoucherObj.phanTramGiamGia;
      }
      else { // không nhận lại được data do vấn đề gì đó: khả năng mã voucher ko dúng
        console.log("Voucher đã nhập không tồn tại");
        alert("Voucher đã nhập không tồn tại")
      }
    }
    return vDiscount
  }
  function loadUserOrderToSendOrderButton(paramUserObj) { // hàm đổ thông tin order vào nút gửi order
    var vButtonSendOrder = document.getElementById("btn-send-order");
    vButtonSendOrder.setAttribute("data-kich-co", paramUserObj.menuDuocChon.menuName);
    vButtonSendOrder.setAttribute("data-duong-kinh", paramUserObj.menuDuocChon.duongKinhCM);
    vButtonSendOrder.setAttribute("data-suon", paramUserObj.menuDuocChon.suonNuong);
    vButtonSendOrder.setAttribute("data-salad", paramUserObj.menuDuocChon.saladGr);
    vButtonSendOrder.setAttribute("data-loai-pizza", paramUserObj.loaiPizza);
    vButtonSendOrder.setAttribute("data-voucher-id", paramUserObj.voucherID);
    vButtonSendOrder.setAttribute("data-ma-nuoc-uong", paramUserObj.loaiNuocUong);
    vButtonSendOrder.setAttribute("data-so-luong-nuoc", paramUserObj.menuDuocChon.drink);
    vButtonSendOrder.setAttribute("data-ho-ten", paramUserObj.hoVaTen);
    vButtonSendOrder.setAttribute("data-thanh-tien", paramUserObj.menuDuocChon.priceVND);
    vButtonSendOrder.setAttribute("data-email", paramUserObj.email);
    vButtonSendOrder.setAttribute("data-so-dien-thoai", paramUserObj.dienThoai);
    vButtonSendOrder.setAttribute("data-dia-chi", paramUserObj.diaChi);
    vButtonSendOrder.setAttribute("data-loi-nhan", paramUserObj.loiNhan);
  }
  function callApiCreateOrder(paramRequest, paramOrderObjRequest) { // hàm mở và gửi request tạo order
    const vBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
    paramRequest.open("POST", vBASE_URL, true);
    paramRequest.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
    paramRequest.send(JSON.stringify(paramOrderObjRequest));
  }
  function handleCreateOrderResponse(paramRequest) { // hàm xử lý response của request tạo order
    var vResponseText = paramRequest.responseText;
    console.log("%cTạo order thành công! Response Text là:", "color:green");
    console.log(vResponseText);
    var vJSONOrderObj = JSON.parse(vResponseText);
    var vOrderId = vJSONOrderObj.orderId;
    console.log("Order Id là: " + vOrderId);
    displayOrderIdToWeb(vOrderId); // hiển thị order Id ra web
    loadIdAndOrderIdToNavOrderDetail(vJSONOrderObj) // gán id và orderId vào nút nav order detail
  }
  function displayOrderIdToWeb(paramOrderId) { // hàm hiển thị order Id ra web
    document.getElementById("div-container-order").style.display = "none";
    document.getElementById("div-display-orderId").style.display = "block"; 
    document.getElementById("input-orderId").value = paramOrderId;
  }
  function loadIdAndOrderIdToNavOrderDetail(paramOrderObj) { // hàm gán id và orderId vào nút nav order detail
    var vNavOrderDetail = document.getElementById("nav-order-detail");
    vNavOrderDetail.setAttribute("data-id", paramOrderObj.id);
    vNavOrderDetail.setAttribute("data-order-id", paramOrderObj.orderId);
    vNavOrderDetail.addEventListener("click", function() {
      onNavOrderDetailClick(this)
    })
  }
</script>
</html>